#!/bin/bash

#############################################
#                                           #
# VNET LOGIN SHELL VER 2.1.28.4 2023/04/19  #
#                                           #
#############################################

line=(`awk 'NR==2' /usr/local/vnet_auth/config.dat`)
arr2=( `echo $line | tr -s ',' ' '`)

vnet_path="/usr/local/vnet_auth/"
result=0
key=''

VnCount=`ps -ef | grep vnet-link | grep -v grep | wc -l`

case "$1" in
  "stop")
    if [ $VnCount -gt 0 ]; then
      # vnet-linkプロセスが起動していた場合
      echo "ASアドレスを入力(例:http://192.168.xxx.xxx) ※　何も入力しない場合はデフォルトで「ntm200.com」が宛先になります。"
      read as_address
      if [ "${arr2[0]}" = "" ]; then
      echo "FQDNを入力(例:hoge.hoge.ntm200.com)"
      else
      echo "FQDNを入力(前回:"${arr2[0]}")　※　何も入力しない場合は前回の VNET ID を使用します。"
      fi
      read fqdn
      echo "パスワードを入力"
      stty -echo
      read password
      stty echo
      if [ "$fqdn" = "" ]; then
          fqdn=${arr2[0]}
      fi
      if [ "$as_address" = "" ]; then
        response=`wget -q -O- --post-data='fqdn='$fqdn'&password='$password'&query=logout' 'https://ntm200.com/api/login_check_json.php'`
      else
        response=`wget -q -O- --post-data='fqdn='$fqdn'&password='$password'&query=logout' $as_address'/api/login_check_json.php'`
      fi
      #echo $response
      result=`echo $response | grep -o '"result": "[^"]*' | grep -o '[^"]*$'`
      if [ "$result" = "1" ]; then
      echo "認証に成功しました"
      # vnet-linkを終了
      VnPID=$(pgrep vnet-link)
      kill -9 $VnPID
      echo "VNETを停止しました"
      else
      echo "認証に失敗しました"
      fi
    fi
  ;;
  *)
    if [ $VnCount -gt 0 ]; then
      # vnet-linkプロセスが起動していた場合
      # vnet-linkを終了
      VnPID=$(pgrep vnet-link)
      kill -9 $VnPID
    fi

    echo "ASアドレスを入力(例:http://192.168.xxx.xxx) ※　何も入力しない場合はデフォルトで「ntm200.com」が宛先になります。"
    read as_address
    if [ "${arr2[0]}" = "" ]; then
      echo "FQDNを入力(例:hoge.hoge.ntm200.com)"
    else
      echo "FQDNを入力(前回:"${arr2[0]}")　※　何も入力しない場合は前回の VNET ID を使用します。"
    fi
    read fqdn
    echo "パスワードを入力"
    stty -echo
    read password
    stty echo
    if [ "$fqdn" = "" ]; then
    	fqdn=${arr2[0]}
    fi
    if [ "$as_address" = "" ]; then
      response=`wget -q -O- --post-data='fqdn='$fqdn'&password='$password'&query=login' 'https://ntm200.com/api/login_check_json.php'`
    else
      response=`wget -q -O- --post-data='fqdn='$fqdn'&password='$password'&query=login' $as_address'/api/login_check_json.php'`
      #ローカルのhttps接続のエラーはノーチェックとする
      #response=`wget -q -O- --no-check-certificate  --post-data='fqdn='$fqdn'&password='$password'&query=login' $as_address'/api/login_check_json_ts.php'

    fi
    #echo $response
    result=`echo $response | grep -o '"result": "[^"]*' | grep -o '[^"]*$'`
    key=`echo $response | grep -o '"key": "[^"]*' | grep -o '[^"]*$'`
    response_as_address=`echo $response | grep -o '"ad_address": "[^"]*' | grep -o '[^"]*$'`

    if [ "$result" = "1" ]; then
      echo "認証に成功しました"
      # keyをファイルに出力
      echo $key > "$vnet_path"kenad.key
      # adアドレスをファイルに出力（上書き）
      echo $response_as_address > "$vnet_path"config.dat
      # FQDNをファイルに出力（追記）
      echo $fqdn >> "$vnet_path"config.dat
      # グループ名をファイルに出力（追記）
      echo "vnet" >> "$vnet_path"config.dat
      # ipv4を取得
      ipv4=`hostname -I | awk '{print $1}'`
      # ipv6を取得
      ipv6=`ip a | grep -A 3 $ipv4 | grep inet6 | awk '{print $2}' | awk -F "/" '{print $1}'`
      # ipv4をファイルに出力（追記）
      echo $ipv4 >> "$vnet_path"config.dat
      # ipv6をファイルに出力（追記）
      echo $ipv6 >> "$vnet_path"config.dat
      # VnProject.outを起動
      nohup "$vnet_path"vnet-link > /dev/null 2>&1 &
    else
      echo "認証に失敗しました"
    fi
  ;;
esac
